 /***************************************************************************
                          klog.cpp  -  description
                             -------------------
    begin                : sb dic  7 18:42:45 CET 2002
    copyright            : (C) 2002 by Jaime Robles
    email                : jaime@kde.org
 ***************************************************************************/
/******************************************************************************
 *                                                                            *
 *   This program is free software; you can redistribute it and/or modify     *
*  it under the terms of the GNU General Public License as published by     *
*  the Free Software Foundation; either version 2 of the License, or        *
*  (at your option) any later version.                                      *
 *                                                                            *
*  This program is distributed in the hope that it will be useful,          *
*  but WITHOUT ANY WARRANTY; without even the implied warranty of           *
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
*  GNU General Public License for more details.                             *
 *                                                                            *
*  You should have received a copy of the GNU General Public License        *
*  along with this program; if not, write to the Free Software              *
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA*
 *****************************************************************************/
#include <klocale.h>
#include "klog.h"
//#include <ostream.h>


Klog::Klog(QWidget *parent, const char *name) : klogui(parent, name)
{
//  QTimer::singleShot( 1, this, SLOT(slotUpdateTime()) );

  //time = QTime::currentTime();                // get current time
  QTimer *internalTimer = new QTimer( this ); // create internal timer
  connect( internalTimer, SIGNAL(timeout()), SLOT(slotUpdateTime()) );
  internalTimer->start( 1000 );               // emit signal every 5 seconds

  
  Klog::KLogVersion = "KLog-0.2.2";
  editdeletePixMap = new QPixmap("editdelete.png");
  editdeleteOffPixMap = new QPixmap("editdeleteOff.png");
  qslRecPixMap = new QPixmap("qslRec.png");
  qslRecOffPixMap = new QPixmap("qslRecOff.png");
  qslSenPixMap = new QPixmap("qslSen.png");
  qslSenOffPixMap = new QPixmap("qslSenOff.png");

  Qso qso;
  number = 0;
  mode = "SSB";
  imode = 0;
  band = 2;
  power = 100;
  entiBak = 0;
  needToSave = false;
  callFound = false;
  callLen = 0;
  callLenPrev = 0;
  callLenFound = 0;
  lastDelete = false;
  klogui::qsoDateTime->setAutoAdvance (true);

  klogDir = QDir::homeDirPath()+"/.klog";  // We create the ~/.klog for the logs
  if (!QDir::setCurrent ( klogDir )){
    QDir d1(klogDir);
    dirExist = d1.mkdir(klogDir, true);
  }
  dirExist = QDir::setCurrent ( klogDir ) ;
  
  logFileName = "klog.adi";
  readConf(); // read our data as myQrz, myLocator from ~/.klog/klogrc
  i = 0;
  QString comment;
  comment = "";

// The following is to warn if the cty.dat file is not found
//  if (!(QFile::exists("cty.dat")) ) {
//    cout << "\nAntes del mensaje pero dentro" << endl;
//    QMessageBox::information( this, "KLog warning: cty.dat not found!","I cannot find the cty.dat file", "Ok"  );  
//  }
  
  world.create();
// The following is to create the DXCC tab in the botton box
//  QListViewItem * item = new QListViewItem( klogui::dxcckListView, 0 );
//  item->setText( 0, Name of Entity );
//  item->setText( 0, "N" );



  
  slotClearBtn();                
  modify = false;
  actionSent = false;
  actionRec = false;

  prefixFound = false;
  (klogui::qsoDateTime->dateEdit())->setOrder(QDateEdit::DMY);
  (klogui::QSLSentdateEdit)->setOrder(QDateEdit::DMY);
  (klogui::QSLRecdateEdit)->setOrder(QDateEdit::DMY);
  slotQrzChanged();
};

Klog::~Klog()
{

}


void Klog::slotQrzChanged ()   // We set the QRZ in the QSO
{
  needToSave = true;
  callLen = (klogui::qrzLineEdit->text()).length();
  if ((callLen == 0) && (callLen<callLenPrev)){
    callLenPrev = callLen; // just to avoid a no end loop  
    slotClearBtn();
    slotCancelSearchButton();
    return;    
  }else if (callLen !=0){
    enti = world.findEntity((klogui::qrzLineEdit->text()).upper());

    if (enti!=0){
      entiBak = enti;
      // Only if we detect the entity we look for a previous qso 
      klogui::searchQrzkLineEdit->setText((klogui::qrzLineEdit->text()).upper());
      // most of showWhere was here     
    }
  }
  showWhere(entiBak);
  callLenPrev = callLen;


}

void Klog::slotClearBtn()
// This method clears all for the next QSO
{

  qso.clearQso(); // Clears the qso object
  if (!modify){
    klogui::bandComboBox->setCurrentItem(band);
    klogui::modeComboBox->setCurrentItem(imode);   
  }else{
    klogui::bandComboBox->setCurrentItem(2);
    klogui::modeComboBox->setCurrentItem(0);
   // modify = true;
  }
  Klog::modify = false; // We will add the QSOs
  Klog::actionSent = false;
  Klog::actionRec = false;

  Klog::prefixFound = false; // We will look for the Entity
  klogui::entityTextLabel->setText("");
  Klog::entiBak = 0;
  Klog::enti = 0;
  Klog::callFound = false;
  Klog::callLen = 0;
  Klog::callLenPrev = 0;
  Klog::callLenFound = 0;  
  Klog::lastDelete = false;
  Klog::distance = 0;
  Klog::beam = 0;

 //We update the time.
//  dateTime = QDateTime::currentDateTime();
//  klogui::qsoDateTime->setDateTime(dateTime);
  //After that we clean the call/mode/band
  klogui::qrzLineEdit->clear();
  klogui::remarksTextEdit->clear();


  
  klogui::iotaComboBox->setCurrentItem(0);
  klogui::iotaIntSpinBox->setValue(0);
  klogui::iotaIntSpinBox->setEnabled(false);
  klogui::TSendBox->setValue(9);
  klogui::SSendBox->setValue(9);
  klogui::RSendBox->setValue(5);
  klogui::TRecBox->setValue(9);
  klogui::SRecBox->setValue(9);
  klogui::RRecBox->setValue(5);
  klogui::okBtn->setText(i18n("Ok"));
  klogui::clearBtn->setText(i18n("Clear"));
  klogui::entityTextLabel->setText("");
  klogui::prxTextLabel->setText("");
  klogui::continentTextLabel->setText("");
  klogui::cqLCDNumber->display(00);
  klogui::ituLCDNumber->display(00);
  klogui::QSLSentcheckBox->setChecked(false);
  klogui::QSLReccheckBox->setChecked(false);
  klogui::powerSpinBox->setValue(90);
  klogui::qthkLineEdit->clear();
  klogui::namekLineEdit->clear();
  qslSen = QDate::fromString("0000-00-00",Qt::ISODate);
  (klogui::QSLSentdateEdit)->setDate(qslSen);
  (klogui::QSLSentdateEdit)->setEnabled(false);
  qslRec = QDate::fromString("0000-00-00",Qt::ISODate);
  (klogui::QSLRecdateEdit)->setDate(qslRec);
  (klogui::QSLRecdateEdit)->setEnabled(false);
  klogui::qslVialineEdit->setDisabled(true); // Next is the QSL info
  klogui::QSLInfotextEdit->setDisabled(true);
  klogui::qslVialineEdit->clear();
  klogui::QSLInfotextEdit->clear();
  klogui::QSLcomboBox->setCurrentItem(0);
  klogui::LedtextLabel->setText(i18n( "<p align=\"center\"><b>KLog</b></p>"));
  klogui::beamshortlCDNumber->display(0);
  klogui::distancelCDNumber->display(0);  
  
  klogui::newEntitykLed->setColor(QColor::QColor( 100, 100, 100 ) );
  klogui::k2Led->setColor(QColor::QColor( 100, 100, 100 ) );
  klogui::k6Led->setColor(QColor::QColor( 100, 100, 100 ) );    
  klogui::k10Led->setColor(QColor::QColor( 100, 100, 100 ) );
  klogui::k12Led->setColor(QColor::QColor( 100, 100, 100 ) );
  klogui::k15Led->setColor(QColor::QColor( 100, 100, 100 ) );
  klogui::k17Led->setColor(QColor::QColor( 100, 100, 100 ) );
  klogui::k20Led->setColor(QColor::QColor( 100, 100, 100 ) );
  klogui::k30Led->setColor(QColor::QColor( 100, 100, 100 ) );
  klogui::k40Led->setColor(QColor::QColor( 100, 100, 100 ) );
  klogui::k80Led->setColor(QColor::QColor( 100, 100, 100 ) );
  klogui::k160Led->setColor(QColor::QColor( 100, 100, 100 ) );


  klogui::locatorLineEdit->clear();
//  QAction::iconSet ()

//  klogui::qslSendAction->setIconSet(QIconSet(*qslSenOffPixMap));
//  klogui::qslRecAction->setIconSet(QIconSet(*qslRecOffPixMap ));
//  klogui::deleteQsoAction->setIconSet(QIconSet(*editdeleteOffPixMap ));

//  klogui::qslSendAction->setEnabled(false);
//  klogui::deleteQsoAction->setEnabled(false);
//  klogui::qslRecAction->setEnabled(false);

}

void Klog::slotOkBtn()
// The QSO is entered!!!
{
  number++;
  readQso();
  if ((qso.getQrz()).length() >= 3){//There are no qrz with less than 3char
   if (!modify){
      logbook.append(qso);
      band = klogui::bandComboBox->currentItem();
      imode = klogui::modeComboBox->currentItem();
      if (enti != 0){
       // if(!dxcc.isWorked(enti)){
          dxcc.worked(enti,klogui::bandComboBox->currentItem(),klogui::modeComboBox->currentItem());
          waz.worked( (world.getEntByNumb(enti)).getCqz() ,klogui::bandComboBox->currentItem(),klogui::modeComboBox->currentItem());
         // klogui::LedtextLabel->setText(i18n( "<p align=\"center\"><b>It's a new one!</b></p>"));
       // }
      }     
    }else{ // We are not ADDING but modifying a QSO.
      number--; 
      modifyQso();

    }
    showQso();
   }//Closes the empty call check
    slotClearBtn();
    showLogList();
}


void Klog::fileSave()
{
  adifFileSave(); // Saving as ADIF

}

void Klog::fileSaveAs(){
  bool writ;
  writ = false;
  while (!writ){

    QString fn = QFileDialog::getSaveFileName(
                    klogDir,
                    "ADIF (*.adi *.ADI);;Tlf (*.log)",
                    this,
                    i18n("save file dialog"
                    "Choose a filename to save under") );

    if ( !fn.isEmpty() ) 
      logFileName = fn;
    QFile file( logFileName );
    if ( file.exists( ) ) {


     switch( QMessageBox::information( this, i18n("Warning - File exists"),
                                      i18n("The file: " + logFileName +" already exits.\n"
                                      "Do you want to overwrite?"),
                                      i18n("Overwrite"), i18n("Cancel"), i18n("Rename"),
                                      0, 1 ) ) {
    case 0:
        writ = true;
        break;
    case 1:
    default: // just for sanity
        return;
        break;
    case 2:
        break;
    }





    
    }else{
      writ = true; 
    }


}
                    
  if ( !logFileName.isEmpty() ) {

    adifFileSave();
    
  } else {
    statusBar()->message( i18n("Saving aborted"), 2000 );
    
  }
}


void Klog::adifFileSave(){
  
  QFile file( logFileName );
  if ( file.open( IO_WriteOnly ) ) {
    QTextStream stream( &file );
    Klog::LogBook::iterator it;
    stream << "ADIF v1.0 (some ADIF v2 fields) Export from " + Klog::KLogVersion + " \nhttp://jaime.robles.nu/klog\n<EOH>\n"<< endl;

    for ( it = logbook.begin(); it != logbook.end(); ++it ){

        stream << "<CALL:" <<((*it).getQrz()).length() << ">" << (*it).getQrz()
         << " " << "<QSO_DATE:8>" << (*it).getDateTime().toString("yyyyMMdd")
        << " " << "<TIME_ON:4>" << (*it).getDateTime().toString("hhmm")
        << " " << "<MODE:" << ((*it).getMode()).length() << ">" << ((*it).getMode()).upper()
        << " " << "<BAND:" << ((*it).getBand()).length() << ">" << ((*it).getBand()).upper()
        << " " << "<RST_SENT:3>" << (*it).getRsttx()
        << " " << "<RST_RCVD:3>" << (*it).getRstrx()
        << " " << "<TX_PWR:" << ((*it).getPower()).length() << ">" << (*it).getPower()

        << " " << "<QSL_RCVD:1>" << (*it).isQslRec()
        << " " << "<QSL_SENT:1>" << (*it).isQslSent();
        if ((*it).getIotaNumber()!= 0)
          stream << " " << "<IOTA:" <<((*it).getIota()).length() << ">" << (*it).getIota();

        if (((*it).getName()).length()>= 2)
          stream << " " << "<NAME:" <<((*it).getName()).length() << ">" << (*it).getName();
          
        if (((*it).getQth()).length()>= 2)
          stream << " " << "<QTH:" <<((*it).getQth()).length() << ">" << (*it).getQth();

        if (((*it).getOperator()).length()>= 3)
          stream << " " << "<OPERATOR:" <<((*it).getOperator()).length() << ">" << (*it).getOperator();

        if ((((*it).getLocator()).length() == 6) || (((*it).getLocator()).length() == 6))
          stream << " " << "<GRIDSQUARE:" <<((*it).getLocator()).length() << ">" << (*it).getLocator();

        if ((*it).sentTheQSL()){
          stream << " " << "<QSLSDATE:8>" << (*it).getQslSenDate().toString("yyyyMMdd");
        }
        if ((*it).gotTheQSL()){
          stream << " " << "<QSLRDATE:8>" << (*it).getQslRecDate().toString("yyyyMMdd");
        }



        if (((*it).getQslVia()).compare("No QSL") == 0){ //Write nothing

        }else{
          if ((*it).getQslVia() == "Manager"){ //If there is a manager
            if (((*it).getQslManager()).length()>0)
              stream << " " << "<QSL_VIA:" <<((*it).getQslManager()).length() << ">" << (*it).getQslManager();
          }//There is no manager but there is QSL via
          else{
            if ((((*it).getQslVia()).length())>0)
              stream << " " << "<QSL_VIA:" <<((*it).getQslVia()).length() << ">" << (*it).getQslVia();
          }
        }
        if ( ((*it).getQslInfo().length()) >= 1){
          stream << " " << "<QSLMSG:" <<((*it).getQslInfo()).length() << ">" << (*it).getQslInfo();          
        }
        if (((*it).getComment()).length()>0)        
          stream << " " << "<COMMENT:" << ((*it).getComment()).length() << ">" << (*it).getComment();
        stream << "<EOR>" << endl;
    }
    file.close();
  }
  needToSave = false;
  
}

 //  QString qslVia;     // QSL_VIA (C) //Manager
 // QString qslInfo;    // ADDRESS
 
void Klog::adifReadLog(const QString& tfileName){
  bool qslViac = false;
  QFile file( tfileName );
  if ( file.open( IO_ReadOnly ) ) {
    QTextStream stream( &file );
    QString line;
    QString adifTab;
    QString theData;
    QString dateString = "";
    QString timeString = "";
    QString datesString = "";
    QString daterString = "";    
    
    int len; // for the tab length
    QString data = "";
    int aux = 0;
    while ( !stream.eof()  && (aux == 0)) {
      data = stream.readLine();
      if (data.upper().contains("<EOH>") != 0)
        aux = 1;
    }
    data = ""; //
    while (!stream.eof()){
      data = stream.readLine();
      if(!data.isEmpty()){
        data = data.simplifyWhiteSpace().upper();
        aux = data.contains('<');
        QStringList fields = QStringList::split('<', data );
        for (int a = 0; a < aux-1; a++){
          if (fields[a].contains("EOR>") == 0){
            adifTab = fields[a].section(':',0,0);
            len = (fields[a].section(':',1)).section('>',0,0).toInt();
            theData = ((fields[a].section(':',1)).section('>',1));
            theData.truncate(len);
            if (adifTab == "CALL"){
              qso.setQrz(theData.upper());
              enti = world.findEntity(theData.upper());
            }else if (adifTab == "QSO_DATE"){
              dateString = theData;
              dateString.insert(4,'-');
              dateString.insert(7,'-');
            }else if (adifTab == "TIME_ON"){
              timeString = theData;
              if (len == 4){
                timeString.insert(2,':');
                timeString = timeString + ":00";
               }else {
                  timeString.insert(13,":");
              }
            }else if (adifTab == "RST_RCVD"){
              qso.setRstrx(theData.toInt());
            }else if (adifTab == "RST_SENT"){
              qso.setRsttx(theData.toInt());
            }else if (adifTab == "BAND"){
              qso.setBand(theData.upper());
            }else if (adifTab == "MODE"){
              qso.setMode(theData.upper());
            }else if (adifTab == "TX_PWR"){
              qso.setPower(theData.upper());
            }else if (adifTab == "COMMENT"){
              qso.setComment(theData);
            
            }else if (adifTab == "QSLSDATE"){
              datesString = theData;
              datesString.insert(4,'-');
              datesString.insert(7,'-');
              
            }else if (adifTab == "QSLRDATE"){
              daterString = theData;
              daterString.insert(4,'-');
              daterString.insert(7,'-');
            }else if (adifTab == "QSL_RCVD"){
              qso.QslRec(theData[0]);
            }else if (adifTab == "QSL_SENT"){
              qso.QslSent(theData[0]);
            }else if (adifTab == "QSL_VIA"){ //Manager?
              if (theData == "No QSL"){
                qso.setQslVia(theData);
                qslViac = true;
              }else if (theData == "Bureau"){
                qso.setQslVia(theData);
                qslViac = true;
              }else if (theData == "QRZ.com"){
                qso.setQslVia(theData);
                qslViac = true;                
              }else if (theData == "Direct"){
                qso.setQslVia(theData);
                qslViac = true;
              }else{
                qso.setQslVia("Manager");
                qso.setQslManager(theData);
                qslViac = true;              
              }
            }else if (adifTab == "QSLMSG"){
              qso.setQslInfo(theData);              
            }else if (adifTab == "GRIDSQUARE"){
             if(locator.isValidLocator(theData)) 
              qso.setLocator(theData);
            }else if (adifTab == "IOTA"){
              qso.setIota(theData);
            }else if (adifTab == "OPERATOR"){
              qso.setOperator(theData);
//            }else if (adifTab == "STATE"){
            }else if (adifTab == "NAME"){
              qso.setName(theData);
            }else if (adifTab == "QTH"){
              qso.setQth(theData);

            };
          }else{
          }
        }
        dateString = dateString+"T"+timeString;
        Klog::number++;
        qso.setNumb(Klog::number);            
        qso.setDateTime(QDateTime::fromString(dateString, Qt::ISODate));
        if (qso.gotTheQSL()){
          qso.setQslRecDateOn(QDate::fromString(daterString, Qt::ISODate));
//          if (!dxcc.isConfirmed(enti))
            dxcc.confirmedString(enti, qso.getBand(), qso.getMode());
            waz.confirmedString( (world.getEntByNumb(enti)).getCqz() ,qso.getBand(),qso.getMode());
         }                 
        if (qso.sentTheQSL())
          qso.setQslSenDateOn(QDate::fromString(datesString, Qt::ISODate));
        if (!qslViac){
          qso.setQslVia("No QSL");
          qslViac = false; 
        }
          logbook.append(qso);
          qso.clearQso();


//        if (!dxcc.isWorkedBand(enti, ))
          dxcc.workedString(enti, qso.getBand(), qso.getMode());
          waz.workedString( (world.getEntByNumb(enti)).getCqz() ,qso.getBand(),qso.getMode());          

        QListViewItem * item = new QListViewItem( klogui::logListView, 0 );
        item->setText( 0, QString::number(qso.getNumb()) );
        item->setText( 1, qso.getDateTime().toString("yyyy-MM-dd") );
        item->setText( 2, qso.getDateTime().toString("hh:mm") );
        item->setText( 3, qso.getQrz().upper() );
        item->setText( 4, QString::number(qso.getRsttx()) );
        item->setText( 5, QString::number(qso.getRstrx()) );
        item->setText( 6, qso.getBand() );
        item->setText( 7, qso.getMode() );
        item->setText( 8, qso.getPower() );
        item->setText( 9, qso.getComment() );
         
      }
    }
    klogui::DXCCworkedlCDNumber->display(dxcc.howManyWorked());
    klogui::DXCClCDNumber->display(dxcc.howManyConfirmed());
    klogui::WAZworkedlCDNumber->display(waz.howManyWorked());
    klogui::WAZlCDNumber->display(waz.howManyConfirmed());

    file.close();
  }
}

void Klog::toEditQso(){
  Klog::modify = true;
  klogui::qsoDateTime->setDateTime(qso.getDateTime()); // date
  klogui::qrzLineEdit->setText(qso.getQrz());
  klogui::RSendBox->setValue( (QString::number(qso.getRsttx()).at(0)).digitValue() );
  klogui::SSendBox->setValue( (QString::number(qso.getRsttx()).at(1)).digitValue() );
  klogui::TSendBox->setValue( (QString::number(qso.getRsttx()).at(2)).digitValue() );
  klogui::RRecBox->setValue( (QString::number(qso.getRstrx()).at(0)).digitValue() );
  klogui::SRecBox->setValue( (QString::number(qso.getRstrx()).at(1)).digitValue() );
  klogui::TRecBox->setValue( (QString::number(qso.getRstrx()).at(2)).digitValue() );
  klogui::modeComboBox->setCurrentText(qso.getMode());
  klogui::bandComboBox->setCurrentText(qso.getBand());
  klogui::powerSpinBox->setValue((qso.getPower()).toInt());
  klogui::remarksTextEdit->setText(qso.getComment());
  klogui::QSLSentcheckBox->setChecked(qso.sentTheQSL());
  klogui::QSLReccheckBox->setChecked(qso.gotTheQSL());
  klogui::QSLSentdateEdit->setDate(qso.getQslSenDate());
  klogui::QSLRecdateEdit->setDate(qso.getQslRecDate());
  if ((qso.getQth()).length() >=2)
    klogui::qthkLineEdit->setText(qso.getQth());
  if ((qso.getName()).length() >=2)    
    klogui::namekLineEdit->setText(qso.getName());
  
  klogui::locatorLineEdit->setText(qso.getLocator());
  // IOTA
  if (qso.getIotaNumber() != 0) {
    klogui::iotaComboBox->setCurrentItem(qso.getIotaContinent());
    klogui::iotaIntSpinBox->setEnabled(true);
    klogui::iotaIntSpinBox->setValue(qso.getIotaNumber());

  }

//If we have sent the QSL
  if (klogui::QSLSentcheckBox->isChecked()){
    (klogui::QSLSentdateEdit)->setEnabled(true);
    (klogui::QSLSentdateEdit)->setDate(qso.getQslSenDate());
      
   }
  else
     (klogui::QSLSentdateEdit)->setEnabled(false);
// If we have received the QSL     
  if (klogui::QSLReccheckBox->isChecked()){
      (klogui::QSLRecdateEdit)->setEnabled(true);
      qslRec =  qso.getQslRecDate(); //We need the qslRec in slotQslRecvBoxChanged     
      (klogui::QSLRecdateEdit)->setDate(qslRec);

     }
  else
     (klogui::QSLRecdateEdit)->setEnabled(false);
     
  //Now the QSl info information

  klogui::QSLcomboBox->setCurrentText(qso.getQslVia());

  if ((qso.getQslVia()).compare("No QSL") == 0){
    klogui::qslVialineEdit->setDisabled(true);
    klogui::QSLInfotextEdit->setDisabled(true);
    klogui::qslVialineEdit->clear();
    klogui::QSLInfotextEdit->clear();

  }else{
    if ((qso.getQslVia()).compare("Manager") == 0){
      klogui::qslVialineEdit->setEnabled(true);
      klogui::qslVialineEdit->setText(qso.getQslManager());
    }      
    else
      klogui::qslVialineEdit->setDisabled(true);

    klogui::QSLInfotextEdit->setEnabled(true);
    klogui::QSLInfotextEdit->setText(qso.getQslInfo());
  }
  // We need enti in other slots
  enti = 0;
  if (((klogui::qrzLineEdit->text()).upper()).length() != 0){
    enti = world.findEntity((klogui::qrzLineEdit->text()).upper());
  }
  showWhere(enti);
}

void Klog::slotQsoSelected(QListViewItem* item){

  if (item){
    slotClearBtn();
//    klogui::qslSendAction->setIconSet(QIconSet(*qslSenPixMap));
 //   klogui::qslRecAction->setIconSet(QIconSet(*qslRecPixMap ));
//    klogui::deleteQsoAction->setIconSet(QIconSet(*editdeletePixMap ));


//    klogui::qslSendAction->setEnabled(true);
//    klogui::deleteQsoAction->setEnabled(true);
//    klogui::qslRecAction->setEnabled(true);
    qso = getByNumber((item->text(0)).toInt());
    toEditQso();
    klogui::okBtn->setText(i18n("Modify"));
    klogui::clearBtn->setText(i18n("Cancel"));
  // The next is to modify the number to allow to modify the qso selected
    Klog::j = (item->text(0)).toInt(); // j is the QSO number
//    Klog::modify = true;
    Klog::prefixFound = false;
    Klog::callFound = false;
    Klog::entiBak = 0;
//    Klog::enti = 0;
    Klog::callLen = 0;
    Klog::callLenPrev = 0;
    Klog::lastDelete = false;
  }

// slotModifyBtn();
}
  
// This slot just change the text from the OKButton to "Modify"
void Klog::slotModifyBtn(){

  klogui::okBtn->setText(i18n("Modify"));

}

Qso Klog::getByNumber(const int n){
/***********************************************************
* We receive a number and we try to get the Qso returning *
* a pointer to it                                          *
************************************************************
*/
  LogBook::iterator iter;
  for ( iter = logbook.begin(); iter != logbook.end(); ++iter ){
    if (n == (*iter).getNumb() )
      return (*iter);
  }
  //Entity not found
  return (*iter);
}


Qso Klog::getByCall(const QString& tqrz){
/***********************************************************
* We receive a call and we try to get the Qso returning *
* a pointer to it                                          *
************************************************************
*/
  LogBook::iterator iter;
  for ( iter = logbook.begin(); iter != logbook.end(); ++iter ){
    if (tqrz.compare(((*iter).getQrz())) == 0)    
      return (*iter);
  }
  //Entity not found
  return (*iter);
}

void Klog::showQso(){
//  This shows the data in the QListView (the botton block)
// The "modify" is still missing
// I have to look for the QSO if modifying

 if (!modify){
    QListViewItem * item = new QListViewItem( klogui::logListView, 0 );   
    item->setText( 0,  QString::number(qso.getNumb()) );
    item->setText( 1, qso.getDateTime().toString("yyyy-MM-dd") );
    item->setText( 2, qso.getDateTime().toString("hh:mm") );
    item->setText( 3, qso.getQrz().upper() );
    item->setText( 4, QString::number(qso.getRsttx()) );
    item->setText( 5, QString::number(qso.getRstrx()) );
    item->setText( 6, qso.getBand() );
    item->setText( 7, qso.getMode() );
    item->setText( 8, qso.getPower() );
    item->setText( 9, qso.getComment() );

  }else{
    QListViewItem *item = klogui::logListView->findItem(QString::number(Klog::j),0);
    if (item){
      item->setText( 0,  QString::number(Klog::j) );
      item->setText( 1, qso.getDateTime().toString("yyyy-MM-dd") );
      item->setText( 2, qso.getDateTime().toString("hh:mm") );
      item->setText( 3, qso.getQrz().upper() );
      item->setText( 4, QString::number(qso.getRsttx()) );
      item->setText( 5, QString::number(qso.getRstrx()) );
      item->setText( 6, qso.getBand() );
      item->setText( 7, qso.getMode());
      item->setText( 8, qso.getPower() );
      item->setText( 9, qso.getComment() );

     }

  }

   klogui::DXCCworkedlCDNumber->display(dxcc.howManyWorked());
   klogui::DXCClCDNumber->display(dxcc.howManyConfirmed());
   klogui::WAZworkedlCDNumber->display(waz.howManyWorked());
   klogui::WAZlCDNumber->display(waz.howManyConfirmed());
   
};

void Klog::fileExit(){
// Check for saving if modified
  if (needToSave){
 switch( QMessageBox::information( this, i18n("Warning - Save log?"),
                                      i18n("The log has been changed since "
                                      "the last save."),
                                      i18n("Save Now"), i18n("Cancel"), i18n("Exit Anyway"),
                                      0, 1 ) ) {
    case 0:
        fileSaveAs();
        break;
    case 1:
    default: // just for sanity
        return;
        break;
    case 2:
        break;
    }
  }
  close();
};

void Klog::fileNew(){
  number = 0;
  klogDir = QDir::homeDirPath()+"./klog";
  logFileName = "klog.adi";
  slotClearBtn();
  modify = false;

  prefixFound = false;
  logbook.clear();
  dxcc.clear();
  waz.clear();
  klogui::logListView->clear();
  
}

void Klog::fileOpen(){
//  QString fileName;
  QFileDialog fileOpenDialog(this, i18n("Open a file"), TRUE);
  fileOpenDialog.setFilter(i18n("ADIF files (*.adi *.ADI)"));
  fileOpenDialog.setDir(klogDir);  
  if (fileOpenDialog.exec() == QDialog::Accepted)
    logFileName=fileOpenDialog.selectedFile();
  else
    return;
  dxcc.clear();
  waz.clear();

  if(!logbook.empty()){ //If we are using a log we have to clear it
    logbook.clear();
    klogui::logListView->clear();
  }
    adifReadLog(logFileName);
};



void Klog::slotQslSentBoxChanged(){
  if (enti == 0)
    return;


  if (!modify){
    qslSen = QDate::currentDate();
  }
  if (klogui::QSLSentcheckBox->isChecked()){
    qso.QslSent('Y');
    (klogui::QSLSentdateEdit)->setEnabled(true);
    if (!modify)
      (klogui::QSLSentdateEdit)->setDate(qslSen);}
  else{
    qso.QslSent('N');
    (klogui::QSLSentdateEdit)->setEnabled(false);
    if (!modify)
      (klogui::QSLSentdateEdit)->setDate(qslSen);
    else
        qslSen = QDate::fromString("0000-00-00",Qt::ISODate);
  }
  if ( (!modify) && (qso.sentTheQSL()) )
    qso.setQslSenDateOn(qslSen);
};






void Klog::slotQslRecvBoxChanged(){

  if (enti == 0)
    return;

  // If we are modifying the date should be the previous one if existed
  if (!modify)
    qslRec = QDate::currentDate();
  //else
  //  if (qslRec == QDate::fromString("0000-00-00",Qt::ISODate))
  //    qslRec = QDate::fromString("0000-00-00",Qt::ISODate);

  if (klogui::QSLReccheckBox->isChecked()){ // The QSO is confirmed
    qso.QslRec('Y');
    (klogui::QSLRecdateEdit)->setEnabled(true);
    (klogui::QSLRecdateEdit)->setDate(qslRec);

//    if ((!dxcc.isConfirmed(enti)))
        dxcc.confirmedString(enti,(klogui::bandComboBox->currentText()).upper() ,  (klogui::modeComboBox->currentText()).upper());          
        waz.confirmedString( (world.getEntByNumb(enti)).getCqz() ,qso.getBand(),qso.getMode());    
  }else{ // The QSO is NOT confirmed
    qso.QslRec('N');
    (klogui::QSLRecdateEdit)->setEnabled(false);
    if (!modify){
      (klogui::QSLRecdateEdit)->setDate(qslRec);

      if (dxcc.isConfirmed(enti)){
        dxcc.notConfirmedString(enti, (klogui::bandComboBox->currentText()).upper(),  (klogui::modeComboBox->currentText()).upper());
        waz.notConfirmedString( (world.getEntByNumb(enti)).getCqz() ,qso.getBand(),qso.getMode());        
      }
    }else{ // I am modifying


      if (dxcc.isConfirmed(enti)){
        dxcc.notConfirmedString(enti, (klogui::bandComboBox->currentText()).upper(), (klogui::modeComboBox->currentText()).upper());
        waz.notConfirmedString( (world.getEntByNumb(enti)).getCqz() ,qso.getBand(),qso.getMode());        
      }
    }
  } 
  if ((!modify) && (qso.gotTheQSL()))
    qso.setQslRecDateOn(qslRec);

  klogui::DXCClCDNumber->display(dxcc.howManyConfirmed());
  klogui::WAZlCDNumber->display(waz.howManyConfirmed());  

};

void Klog::readQso(){ //Just read the values an fill the qso

// Calculating RST values
  i = klogui::TSendBox->value();
  rsttx = i;
  i = klogui::SSendBox->value() * 10;
  rsttx = rsttx + i;
  i = klogui::RSendBox->value() * 100;
  rsttx = rsttx + i;
  
  i = klogui::TRecBox->value();
  rstrx = i;
  i = klogui::SRecBox->value() * 10;
  rstrx = rstrx + i;
  i = klogui::RRecBox->value() * 100;
  rstrx = rstrx + i;
// QRZ...
  qso.setQrz((klogui::qrzLineEdit->text()).upper());
  qso.setNumb (number);
  if (!modify)
    {
      dateTime = QDateTime::currentDateTime();
    }
  else
    {
      dateTime =   klogui::qsoDateTime->dateTime();
    }
  
  qso.setDateTime(dateTime);
//cout << "\nDate: "<< qso.getDateTime().toString("yyyyMMdd") << endl;
  qso.setRstrx(rstrx);
  qso.setRsttx(rsttx);
  qso.setBand ((klogui::bandComboBox->currentText()).upper());
  qso.setMode((klogui::modeComboBox->currentText()).upper());
  qso.setPower((klogui::powerSpinBox->text()).upper());
  // Running the QSL card slots
 // if (!modify){
    slotQslRecvBoxChanged();
    slotQslSentBoxChanged();
  //}    
  slotIOTAChanged();
  if ((klogui::remarksTextEdit->text()).length() >0)
    qso.setComment(klogui::remarksTextEdit->text());
  qso.setQslVia(klogui::QSLcomboBox->currentText());
  // Check if the locator is valid
  if (locator.isValidLocator((klogui::locatorLineEdit->text()).upper()))
    qso.setLocator((klogui::locatorLineEdit->text()).upper());

    
  if(klogui::qslVialineEdit->isEnabled())
    qso.setQslManager((klogui::qslVialineEdit->text()).upper());

    
  if(klogui::QSLInfotextEdit->isEnabled())
    qso.setQslInfo(klogui::QSLInfotextEdit->text());

  if((klogui::namekLineEdit->text()).length() >= 2)
    qso.setName((klogui::namekLineEdit->text()).upper());

  if((klogui::qthkLineEdit->text()).length() >= 2)
    qso.setQth((klogui::qthkLineEdit->text()).upper());
    
};

void Klog::modifyQso(){ // Modify an existing QSO with the data on the boxes

  LogBook::iterator iter;
//  cout << "\nNumber j: " << QString::number(j) << endl;
  for ( iter = logbook.begin(); iter != logbook.end(); ++iter ){
    if ( Klog::j == (*iter).getNumb() ){

      (*iter).setQrz( (klogui::qrzLineEdit->text()).upper() );
//      (*iter).setDateTime(dateTime);
      (*iter).setDateTime(klogui::qsoDateTime->dateTime());
//cout << "\nNumber: "<< (*iter).getNumb() << "Date: "<< (*iter).getDateTime().toString("yyyyMMdd") << endl;

//      (*iter).getDateTime();
      (*iter).setRstrx(rstrx);
      (*iter).setRsttx(rsttx);
      (*iter).setBand ((klogui::bandComboBox->currentText()).upper());
      (*iter).setMode((klogui::modeComboBox->currentText()).upper());
      (*iter).setPower((klogui::powerSpinBox->text()).upper());

      if ((klogui::remarksTextEdit->text()).length() >0)      
        (*iter).setComment(klogui::remarksTextEdit->text());
      if((klogui::namekLineEdit->text()).length() >= 2)
        (*iter).setName((klogui::namekLineEdit->text()).upper());

      if((klogui::qthkLineEdit->text()).length() >= 2)
        (*iter).setQth((klogui::qthkLineEdit->text()).upper());
        
      if ((klogui::iotaIntSpinBox->value() != 0)) // IOTA
        (*iter).setIota(iota);   
      if (locator.isValidLocator((klogui::locatorLineEdit->text()).upper() ))
        (*iter).setLocator( (klogui::locatorLineEdit->text()).upper() );      
      if (klogui::QSLSentcheckBox->isChecked()){
//        (*iter).QslSent('Y');
        qslSen = klogui::QSLSentdateEdit->date();
        (*iter).setQslSenDateOn(qslSen);
      }else{
        (*iter).QslSent('N');
      }
     
      if (klogui::QSLReccheckBox->isChecked()){
  //      (*iter).QslRec('Y');
        qslRec = klogui::QSLRecdateEdit->date();
        (*iter).setQslRecDateOn(qslRec);
        if ((*iter).gotTheQSL()){
//          if (!dxcc.isConfirmed(enti))
            dxcc.confirmedString(enti, (*iter).getBand(), (*iter).getMode());
            waz.confirmedString( (world.getEntByNumb(enti)).getCqz() ,(*iter).getBand(),(*iter).getMode());            
            
        }
    }else{
      (*iter).QslRec('N');
      if (dxcc.isConfirmed(enti)){
        dxcc.notConfirmedString(enti, (klogui::bandComboBox->currentText()).upper(), (klogui::modeComboBox->currentText()).upper());
        waz.notConfirmedString( (world.getEntByNumb(enti)).getCqz() ,(klogui::bandComboBox->currentText()).upper(), (klogui::modeComboBox->currentText()).upper());
      }
    }
    (*iter).setQslVia(klogui::QSLcomboBox->currentText()); //QSL Info
    if(klogui::qslVialineEdit->isEnabled())
      (*iter).setQslManager(klogui::qslVialineEdit->text());
    if(klogui::QSLInfotextEdit->isEnabled())
      (*iter).setQslInfo(klogui::QSLInfotextEdit->text());
  }

  }
};

  
void Klog::helpAbout(){
/*  QString description;

  description = "The KDE Ham Radio Logging program";
  KAboutData aboutData( "klog", I18N_NOOP("Klog"), KLogVersion, description, KAboutData::License_GPL, "(c) 2002, Jaime Robles, EA4TV", 0, 0, "jaime@kde.org");
  aboutData.addAuthor("Jaime Robles, EA4TV",0, "jaime@kde.org");
//  KAboutApplication kAbout(this);
  KAboutDialog kAbout(this);

  kAbout.setTitle ("About KLog");
  kAbout.setAuthor("Jaime Robles, EA4TV", "jaime@kde.org", "http:://jaime.robles.nu/klog", "Main Developer");
  kAbout.setVersion ( Klog::KLogVersion);
  kAbout.show(this);
*/  
              
QMessageBox::about( this, i18n(Klog::KLogVersion + " - The KDE Ham Radio Logging program"),
                            i18n(Klog::KLogVersion + " - The KDE Ham Radio Logging program\n"
                            "You can find the last version on http://jaime.robles.nu/klog\nJaime Robles, EA4TV, jaime@robles.nu"));
  
};

void Klog::slotQSLcomboBoxChanged(){     
  QString combo = (klogui::QSLcomboBox)->currentText();

  if (combo.compare("No QSL") == 0){
    klogui::qslVialineEdit->setDisabled(true);
    klogui::QSLInfotextEdit->setDisabled(true);
    klogui::qslVialineEdit->clear();
    klogui::QSLInfotextEdit->clear();

  }else{
    if (combo.compare("Manager") == 0)
      klogui::qslVialineEdit->setEnabled(true);
    else
      klogui::qslVialineEdit->setDisabled(true);    

    klogui::QSLInfotextEdit->setEnabled(true);
  }
  
};

// The next slots run/shows the setup dialog to setup KLog
void Klog::slotPreferences(){

/*  KApplication a;
  Setup *setup = new Setup();
  a.setMainWidget(setup);
  setup->show();
  return a.exec();
*/ 


};

void Klog::accept(){
};

void Klog::readConf(){
  QFile file( "klogrc" );
  if ( file.open( IO_ReadOnly ) ) {
    QTextStream stream( &file );
    QString adifTab;
    QString theData;
    QString data = "";

    data = ""; //
    while (!stream.eof()){
      data = stream.readLine();
      if(!data.isEmpty()){ // If there is another line i read it
        data = data.simplifyWhiteSpace().upper();
        QStringList fields = QStringList::split('=', data );

        adifTab = fields[0].upper();
        theData = fields[1].upper();      
        if (adifTab == "CALL"){
          setMyQrz(theData);

          //MyCall(theData.upper());
        }else if (adifTab == "LOCATOR"){
          setMyLocator(theData);
        }else{
        };
        
      }                                               

    }                                                           
    file.close();
  }else{
    // the file klogrc with preferences does not exist so we have to create it
  }
   
};
void Klog::setMyQrz(const QString &tqrz){myQrz = tqrz;};

QString Klog::getMyQrz() const{return myQrz;};

void Klog::setMyLocator(const QString &tlocator){
  if (locator.isValidLocator(tlocator.upper() ))
    myLocator = tlocator;

};

QString Klog::getMyLocator() const{return myLocator;};

void Klog::showWhere(const int enti){
  if ((enti != 0)&&(enti != -1)){
    klogui::entityTextLabel->setText((world.getEntByNumb(enti)).getEntity());
    klogui::prxTextLabel->setText((world.getEntByNumb(enti)).getPfx());
    klogui::continentTextLabel->setText((world.getEntByNumb(enti)).getContinent());
    
 //   klogui::iotaComboBox->setCurrentItem((world.getEntByNumb(enti)).getContinent());
    klogui::cqLCDNumber->display((world.getEntByNumb(enti)).getCqz());
    klogui::ituLCDNumber->display((world.getEntByNumb(enti)).getItuz());
    Klog::distance = locator.getDistanceKilometres(locator.getLon(myLocator), locator.getLat(myLocator), (world.getEntByNumb(enti)).getLon(), (world.getEntByNumb(enti)).getLat());
    beam = locator.getBeam(locator.getLon(myLocator), locator.getLat(myLocator), (world.getEntByNumb(enti)).getLon(), (world.getEntByNumb(enti)).getLat());
    klogui::distancelCDNumber->display(distance);
    klogui::distancellCDNumber->display(40000 - distance);
    klogui::beamshortlCDNumber->display(beam);
    if (beam >= 180)
      klogui::beamlonglCDNumber->display(beam - 180);
    else
      klogui::beamlonglCDNumber->display(180 + beam);
    entityState(entiBak);

    if(dxcc.isConfirmedBand(entiBak, 0)){ // 2m band
      // RED for confirmed
      klogui::k2Led->setColor(QColor::QColor( 216, 0, 0 ) );
    }else{
      if(dxcc.isWorkedBand(entiBak, 0)){
        // Yellow for worked but not confirmed
        klogui::k2Led->setColor(QColor::QColor( 255, 255, 0 ) );
      }else{
        klogui::k2Led->setColor(QColor::QColor( 0, 216, 0 ) );
        //GREEN if new one
      }
    }

if(dxcc.isConfirmedBand(entiBak, 1)){ // 6m band
      // RED for confirmed
      klogui::k6Led->setColor(QColor::QColor( 216, 0, 0 ) );
    }else{
      if(dxcc.isWorkedBand(entiBak, 1)){
        // Yellow for worked but not confirmed
        klogui::k6Led->setColor(QColor::QColor( 255, 255, 0 ) );
      }else{
        klogui::k6Led->setColor(QColor::QColor( 0, 216, 0 ) );
        //GREEN if new one
      }
    }

    if(dxcc.isConfirmedBand(entiBak, 2)){ // 10m band
      // RED for confirmed
      klogui::k10Led->setColor(QColor::QColor( 216, 0, 0 ) );
    }else{
      if(dxcc.isWorkedBand(entiBak, 2)){
        // Yellow for worked but not confirmed
        klogui::k10Led->setColor(QColor::QColor( 255, 255, 0 ) );
      }else{
        klogui::k10Led->setColor(QColor::QColor( 0, 216, 0 ) );
        //GREEN if new one
      }
    }
    
  if(dxcc.isConfirmedBand(entiBak, 3)){ // 12m band
      // RED for confirmed
      klogui::k12Led->setColor(QColor::QColor( 216, 0, 0 ) );
    }else{
      if(dxcc.isWorkedBand(entiBak, 3)){
        // Yellow for worked but not confirmed
        klogui::k12Led->setColor(QColor::QColor( 255, 255, 0 ) );
      }else{
        klogui::k12Led->setColor(QColor::QColor( 0, 216, 0 ) );
        //GREEN if new one
      }
    }


    if(dxcc.isConfirmedBand(entiBak, 4)){ // 15m band
      // RED for confirmed
      klogui::k15Led->setColor(QColor::QColor( 216, 0, 0 ) );
    }else{
      if(dxcc.isWorkedBand(entiBak, 4)){
        // Yellow for worked but not confirmed
        klogui::k15Led->setColor(QColor::QColor( 255, 255, 0 ) );
      }else{
        klogui::k15Led->setColor(QColor::QColor( 0, 216, 0 ) );
        //GREEN if new one
      }
    }


if(dxcc.isConfirmedBand(entiBak, 5)){ // 17m band
      // RED for confirmed
      klogui::k17Led->setColor(QColor::QColor( 216, 0, 0 ) );
    }else{
      if(dxcc.isWorkedBand(entiBak, 5)){
        // Yellow for worked but not confirmed
        klogui::k17Led->setColor(QColor::QColor( 255, 255, 0 ) );
      }else{
        klogui::k17Led->setColor(QColor::QColor( 0, 216, 0 ) );
        //GREEN if new one
      }
    }

   
     if(dxcc.isConfirmedBand(entiBak, 6)){ // 20m band
      // RED for confirmed
      klogui::k20Led->setColor(QColor::QColor( 216, 0, 0 ) );
    }else{
      if(dxcc.isWorkedBand(entiBak, 6)){
        // Yellow for worked but not confirmed
        klogui::k20Led->setColor(QColor::QColor( 255, 255, 0 ) );
      }else{
        klogui::k20Led->setColor(QColor::QColor( 0, 216, 0 ) );
        //GREEN if new one
      }
    }

if(dxcc.isConfirmedBand(entiBak, 7)){ // 30m band
      // RED for confirmed
      klogui::k30Led->setColor(QColor::QColor( 216, 0, 0 ) );
    }else{
      if(dxcc.isWorkedBand(entiBak, 7)){
        // Yellow for worked but not confirmed
        klogui::k30Led->setColor(QColor::QColor( 255, 255, 0 ) );
      }else{
        klogui::k30Led->setColor(QColor::QColor( 0, 216, 0 ) );
        //GREEN if new one
      }
    }    

if(dxcc.isConfirmedBand(entiBak, 8)){ // 40m band
      // RED for confirmed
      klogui::k40Led->setColor(QColor::QColor( 216, 0, 0 ) );
    }else{
      if(dxcc.isWorkedBand(entiBak, 8)){
        // Yellow for worked but not confirmed
        klogui::k40Led->setColor(QColor::QColor( 255, 255, 0 ) );
      }else{
        klogui::k40Led->setColor(QColor::QColor( 0, 216, 0 ) );
        //GREEN if new one
      }
    }


if(dxcc.isConfirmedBand(entiBak, 9)){ // 80m band
      // RED for confirmed
      klogui::k80Led->setColor(QColor::QColor( 216, 0, 0 ) );
    }else{
      if(dxcc.isWorkedBand(entiBak, 9)){
        // Yellow for worked but not confirmed
        klogui::k80Led->setColor(QColor::QColor( 255, 255, 0 ) );
      }else{
        klogui::k80Led->setColor(QColor::QColor( 0, 216, 0 ) );
        //GREEN if new one
      }
    }

if(dxcc.isConfirmedBand(entiBak, 10)){ // 160m band
      // RED for confirmed
      klogui::k160Led->setColor(QColor::QColor( 216, 0, 0 ) );
    }else{
      if(dxcc.isWorkedBand(entiBak, 10)){
        // Yellow for worked but not confirmed
        klogui::k160Led->setColor(QColor::QColor( 255, 255, 0 ) );
      }else{
        klogui::k160Led->setColor(QColor::QColor( 0, 216, 0 ) );
        //GREEN if new one
      }
    }    
    
    }else{
      klogui::beamshortlCDNumber->display(0);
      klogui::distancelCDNumber->display(0);
      klogui::beamlonglCDNumber->display(0);
      klogui::distancellCDNumber->display(0);
    }
};

void Klog::tlfReadLog(const QString& tfileName){
  QFile file( tfileName );
  if ( file.open( IO_ReadOnly ) ) {
    QTextStream stream( &file );
    QString qband;
    QString qmode;
    QString qdate;
    QString qtime;                   
    QString qstx;
    QString qqrz;
    QString qrsttx;
    QString qrstrx;
    QString qstx_string;
    QString qsrx_string;
    QString qauxString;
    QString otherAux;      // NO YEAR
    QString monthString;
    QString dayString;
    QString dateString = "";
    QString timeString = "";
//    int aux;  // Maybe i can delete it
    int len; // for the tab length
    QString data;
    data = ""; //
    while (!stream.eof()){
      data = stream.readLine();
      if(!data.isEmpty()){
        Klog::number++;
        data = data.simplifyWhiteSpace().upper();
        QStringList fields = QStringList::split( ' ', data );
        qauxString = fields[0];
        qdate = fields[1];
        QStringList datelist = QStringList::split( '-', qdate );
        otherAux = datelist[2];
        monthString = datelist[1];
        dayString = datelist[0];    
        if ( (otherAux.toInt())>9) //NOT THE BEST SOLUTION
          otherAux = "19" + otherAux;                        
        else
          otherAux = "20" + otherAux;// only valid till 2009!!!
        if (monthString == "JAN"){
          dateString = otherAux+"-"+"01-"+dayString;
        }else if (monthString == "FEB"){
          dateString = otherAux+"-"+"02-"+dayString;      
        }else if (monthString == "MAR"){
          dateString = otherAux+"-"+"03-"+dayString;      
        }else if (monthString == "APR"){
          dateString = otherAux+"-"+"04-"+dayString;      
        }else if (monthString == "MAY"){
          dateString = otherAux+"-"+"05-"+dayString;      
        }else if (monthString == "JUN"){
          dateString = otherAux+"-"+"06-"+dayString;      
        }else if (monthString == "JUL"){
          dateString = otherAux+"-"+"07-"+dayString;
        }else if (monthString == "AGO"){
          dateString = otherAux+"-"+"08-"+dayString;      
        }else if (monthString == "SEP"){
           dateString = otherAux+"-"+"09-"+dayString;      
        }else if (monthString == "OCT"){
          dateString = otherAux+"-"+"10-"+dayString;      
        }else if (monthString == "NOV"){
          dateString = otherAux+"-"+"11-"+dayString;      
        }else if (monthString == "DEC"){
          dateString = otherAux+"-"+"12-"+dayString;      
        }else{
          
        };
        qtime = fields[2];
        qstx_string = fields[3];
        qqrz = fields[4];
        qrsttx = fields[5];
        qrstrx = fields[6];
        qsrx_string = fields[7];                      
        dateString = dateString + "T" + qtime + ":00";
        len = 0;
        while( (qauxString.at(len)).isDigit()){
          len++;  
        }
        qband = qauxString.left(len)+"M";
        qmode = qauxString.right(qauxString.length()-len); 
        qso.setQrz(qqrz.upper());

        qso.setNumb(Klog::number);
        qso.setDateTime(QDateTime::fromString(dateString, Qt::ISODate));
        qso.setRstrx(qrstrx.toInt());
        qso.setRsttx(qrsttx.toInt());
        qso.setBand(qband.upper());
        qso.setMode(qmode.upper());  
        qso.setPower("0"); // No power known

         if ( !logbook.empty() ) {
        // OK, modify the first item
          logbook.last();
        }
        
        logbook.append(qso);
    //SRX_STRING and STX_STRING are still lost

        QListViewItem * item = new QListViewItem( klogui::logListView, 0 );
        item->setText( 0, QString::number(qso.getNumb()) );
        item->setText( 1, qso.getDateTime().toString("yyyy-MM-dd") );
        item->setText( 2, qso.getDateTime().toString("hh:mm") );
        item->setText( 3, qso.getQrz().upper() );
        item->setText( 4, QString::number(qso.getRsttx()) );
        item->setText( 5, QString::number(qso.getRstrx()) );
        item->setText( 6, qso.getBand() );
        item->setText( 7, qso.getMode() );
        item->setText( 8, qso.getPower() );
        item->setText( 9, qso.getComment() );
      }
    }
  }
  file.close();
};

void Klog::slotImportTlf(){
  QString fileName;
  QFileDialog fileOpenDialog(this, i18n("Open a file"), TRUE);
  fileOpenDialog.setFilter(i18n("TLF files (*.log *.LOG)"));
  fileOpenDialog.setDir(klogDir);
  if (fileOpenDialog.exec() == QDialog::Accepted)
    fileName=fileOpenDialog.selectedFile();
  else
    return;
  tlfReadLog(fileName);
};

void Klog::slotIOTAChanged(){
  klogui::iotaIntSpinBox->setEnabled(true);
  if ((klogui::iotaIntSpinBox->value() != 0)){ // 
    iota = klogui::iotaComboBox->currentText() + "-" + QString::number(klogui::iotaIntSpinBox->value());
    if (!modify)
      qso.setIota(iota);

  }
};


void Klog::entityState(const int tentity){

  int i = tentity;
  
if (dxcc.isConfirmed(i) ){
  
  if(dxcc.isConfirmedBand(i, adif.band2Int((klogui::bandComboBox->currentText()).upper()))){
    // CONFIRMED IN THIS BAND... NO WORK NEEDED
    // LED = RED
    klogui::LedtextLabel->setText(i18n( "<p align=\"center\"><b>Worked & confirmed before</b></p>"));
    klogui::newEntitykLed->setColor(QColor::QColor( 216, 0, 0 ) );    
    
  }else{
    // CONFIRMED BUT NOT IN THIS BAND SO WORK IT!
    if (dxcc.isWorkedBand(i, adif.band2Int((klogui::bandComboBox->currentText()).upper()))){
    // IT IS WORKED IN THIS BAND BUT STILL NOT CONFIRMED, WORK IT!
    // LED = YELLOW
      klogui::LedtextLabel->setText(i18n( "<p align=\"center\"><b>Not confirmed, WORK IT!</b></p>"));    
      klogui::newEntitykLed->setColor(QColor::QColor( 255, 255, 0 ) );   
    }else{
     // IT IS NOT WORKED IN THIS BAND SO WORK IT!
     // LED = GREEN
      klogui::LedtextLabel->setText(i18n( "<p align=\"center\"><b>New one in this band, WORK IT!</b></p>"));         
      klogui::newEntitykLed->setColor(QColor::QColor( 0, 216, 0 ) );
    }
  }

      
}else{
// IT IS NOT CONFIRMED SO WORK IT!
  if (dxcc.isWorked(i)){
    // IT IS WORKED.... BUT NOT CONFIRMED WORK IT!
    if (dxcc.isWorkedBand(i, adif.band2Int((klogui::bandComboBox->currentText()).upper()))){
    // IT IS WORKED IN THIS BAND BUT STILL NOT CONFIRMED, WORK IT!
    // LED = YELLOW
      klogui::LedtextLabel->setText(i18n( "<p align=\"center\"><b>Not confirmed, WORK IT!</b></p>"));        
      klogui::newEntitykLed->setColor(QColor::QColor( 255, 255, 0 ) );
    }else{
    // IT IS NOT WORKED IN THIS BAND, SO WORK IT!
    // LED = GREEN
      klogui::newEntitykLed->setColor(QColor::QColor( 0, 216, 0 ) );    
    }
        
  } else{
    // IT IS A COMPLETE NEW ONE WORK IT AT ANY PRICE!!!!
    // LED = GREEN
      klogui::LedtextLabel->setText(i18n( "<p align=\"center\"><b>NEW ONE, WORK IT!</b></p>"));        
      klogui::newEntitykLed->setColor(QColor::QColor( 0, 216, 0 ) );    
  }
  
}

};

void Klog::slotSearchButton(){

  qrz = (klogui::searchQrzkLineEdit->text()).upper();
  klogui::searchQsoskListView->clear();
//  qso = getByCall(qrz);

  LogBook::iterator iter;
  for ( iter = logbook.begin(); iter != logbook.end(); ++iter ){
//    if (qrz.compare(((*iter).getQrz())) == 0){
//    if (qrz.contains((*iter).getQrz()) > 0){
    if (((*iter).getQrz()).contains(qrz) > 0){  

      i++;
      QListViewItem * item = new QListViewItem( klogui::searchQsoskListView, 0 );
  
      item->setText( 6, QString::number((*iter).getNumb()) );
      item->setText( 0,(*iter).getQrz() );      
      item->setText( 1, (*iter).getDateTime().toString("yyyy-MM-dd") );
      item->setText( 2, (*iter).getBand() );
      item->setText( 3, (*iter).getMode() );
      item->setText( 4, (*iter).isQslSent() );
      item->setText( 5, (*iter).isQslRec() );
      if ( ((*iter).getName()).length() > 1)
        klogui::previousNamekLineEdit->setText((*iter).getName());
      if ( ((*iter).getQth()).length() > 1)
        klogui::previousQthkLineEdit->setText((*iter).getQth());      
    }
  }

};

void  Klog::slotCancelSearchButton(){

  klogui::searchQrzkLineEdit->clear();
  klogui::searchQsoskListView->clear();
  
};

void Klog::slotQrzSearchChanged(){
 slotSearchButton();
  
};
// The following is to select a QSO from the search box
void Klog::slotQsoSearchSelected( QListViewItem * item){
   
  if (item){
    slotClearBtn();
//    klogui::qslSendAction->setIconSet(QIconSet(*qslSenPixMap));
//    klogui::qslRecAction->setIconSet(QIconSet(*qslRecPixMap ));
//    klogui::deleteQsoAction->setIconSet(QIconSet(*editdeletePixMap ));
 
//   klogui::qslSendAction->setEnabled(true);
//   klogui::deleteQsoAction->setEnabled(true);
//   klogui::qslRecAction->setEnabled(true);

    qso = getByNumber((item->text(6)).toInt());
//    cout << "Number Selected: " << QString::number(qso.getNumb()) << endl;
    toEditQso();
    klogui::okBtn->setText(i18n("Modify"));
    klogui::clearBtn->setText(i18n("Cancel"));
  // The next is to modify the number to allow to modify the qso selected
    Klog::j = qso.getNumb(); // j is the QSO number
//    cout << "Number Selected j: " << QString::number(Klog::j) << endl;
    Klog::modify = true;
    Klog::prefixFound = false;
    Klog::callFound = false;
    Klog::entiBak = 0;
//    Klog::enti = 0;
    Klog::callLen = 0;
    Klog::callLenPrev = 0;
    Klog::lastDelete = false;    
  }
};

// We are going to delete a QSO from the log
void Klog::slotDeleteQso(){

  if (!modify){
    return;
  }else{
    LogBook::iterator iter;
    for ( iter = logbook.begin(); iter != logbook.end(); ++iter )
    if ( j == (*iter).getNumb()){

      switch( QMessageBox::information( this, i18n("Warning - QSO Deletion"),
                                      i18n("Do you want to delete the QSO with:\n<b>"
                                      + (*iter).getQrz() + "</b> of " + (*iter).getDateTime().toString("yyyy-MM-dd") + "?"),
 //                                     i18n("Yes"), i18n("No"), i18n("Search next"), 0, 1 ) ) {
                                        i18n("Yes"), i18n("No"), 0, 1 ) ) {
    case 0:
//       logbook.erase(iter);
       showLogList();
      return;
    case 1:
    default: // just for sanity
        return;
        break;
    case 2:
        break;
    }     
  }
  }
};

// To print the whole log in the botton box
void Klog::showLogList(){
  klogui::logListView->clear();
  Klog::LogBook::iterator it;

  for ( it = logbook.begin(); it != logbook.end(); ++it ){
    QListViewItem * item = new QListViewItem( klogui::logListView, 0 );
    item->setText( 0, QString::number((*it).getNumb()) );
    item->setText( 1, (*it).getDateTime().toString("yyyy-MM-dd") );
    item->setText( 2, (*it).getDateTime().toString("hh:mm") );
    item->setText( 3, (*it).getQrz().upper() );
    item->setText( 4, QString::number((*it).getRsttx()) );
    item->setText( 5, QString::number((*it).getRstrx()) );
    item->setText( 6, (*it).getBand() );
    item->setText( 7, (*it).getMode() );
    item->setText( 8, (*it).getPower() );
    item->setText( 9, (*it).getComment() );
  }
 

  
};

void Klog::slotQSLRec(){

};


void Klog::slotQSLSent(){

  actionSent = true;

  if (!qso.sentTheQSL()){
    qslSen = QDate::currentDate();
    qso.QslSent('Y');
  }else{
    qslSen = QDate::fromString("0000-00-00",Qt::ISODate);
    qso.QslSent('N');
  }
 
  qso.setQslSenDateOn(qslSen);

};


void Klog::slotUpdateTime(){
  if (!modify){
    dateTime = QDateTime::currentDateTime();
    klogui::qsoDateTime->setDateTime(dateTime);
  }
};
