/***************************************************************************
                          klog.h  -  description
                             -------------------
    begin                : sb dic  7 18:42:45 CET 2002
    copyright            : (C) 2002 by Jaime Robles
    email                : jaime@kde.org
 ***************************************************************************/

/******************************************************************************
 *                                                                            *
 *   This program is free software; you can redistribute it and/or modify     *
*  it under the terms of the GNU General Public License as published by     *
*  the Free Software Foundation; either version 2 of the License, or        *
*  (at your option) any later version.                                      *
 *                                                                            *
*  This program is distributed in the hope that it will be useful,          *
*  but WITHOUT ANY WARRANTY; without even the implied warranty of           *
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
*  GNU General Public License for more details.                             *
 *                                                                            *
*  You should have received a copy of the GNU General Public License        *
*  along with this program; if not, write to the Free Software              *
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA*
 *****************************************************************************/
#ifndef KLOG_H
#define KLOG_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <kapp.h>
#include <qaction.h>
#include <qapplication.h>
#include <qwidget.h>
#include <klineedit.h>
#include <kcombobox.h>
#include "klogui.h"
#include <qlistview.h>
#include <klistview.h>
#include <qfile.h>
#include <qdatetime.h>
#include <qdatetimeedit.h>
#include <qspinbox.h>
#include <ktextedit.h>
#include <qstring.h>
#include <qlabel.h>
#include <qlcdnumber.h>
#include <kglobal.h>
#include <klocale.h>
#include <kpushbutton.h>
#include <qcheckbox.h>
#include <qmessagebox.h>
#include <qfiledialog.h>
#include <qstatusbar.h>
#include <qcolor.h>
#include <qdialog.h>
#include <qinputdialog.h>
#include <knuminput.h>
#include <kled.h>
#include <kaboutapplication.h>
#include <kaboutdata.h>
#include <qtimer.h>
#include "awarddxcc.h"
#include "awardwaz.h"  
#include "qso.h"
#include "world.h"
#include "entity.h"
#include "locator.h"
//#include "setupui.h"
#include "adif.h"
//#include "ostream.h"

// BANDS 9 {10/12/15/17/20/30/40/80/160}
//MODES 11 {SSB/CW/FM/PSK31/SSTV/RTTY/TOR/PKT/
//          AM/ATV/PAC/CLO
//

const char SEPARATOR = ',';

/** Klog is the base class of the project */
class Klog : public klogui{
  Q_OBJECT
  public:
    /** construtor */
    Klog(QWidget* parent=0, const char *name=0);
    /** destructor */
    ~Klog();
    Qso qso;
    World world;

    Entity entity;

    typedef QValueList<Qso> LogBook;
    LogBook logbook;
    
  public slots:
  void slotUpdateTime();
  void slotQSLRec();
  void slotQSLSent();
  void slotDeleteQso();
  void slotQrzSearchChanged();
  void slotCancelSearchButton();
  void slotSearchButton();
  void slotQrzChanged();
  void slotOkBtn();
  void slotClearBtn();
  void slotQslSentBoxChanged();
  void slotQslRecvBoxChanged();
  void slotQSLcomboBoxChanged();
  void slotPreferences();  
  void fileNew();
  void fileSave();
  void fileSaveAs();
  void adifFileSave();
//  void adifSaveAs(const QString& tfileName);
  void adifReadLog(const QString& tfileName);
  void tlfReadLog(const QString& tfileName);  
  void fileOpen();  
  void fileExit();
  void helpAbout();
  void readQso(); //Just read the values an fill the qso
  void modifyQso(); // Modify an existing QSO with the data on the boxes
  void slotQsoSelected(QListViewItem* item);
  void slotQsoSearchSelected( QListViewItem * item);
  void slotModifyBtn();
  void showLogList();

  Qso getByCall(const QString& tqrz);
  Qso getByNumber(const int n);
  void showQso(); // Gets data from the Input part and show in the botton widget
  void toEditQso(); //Puts the QSO data in the edit box
  void accept();
  private:
  // Awards supported by KLog
    Adif adif;
    AwardDXCC dxcc;
    AwardWAZ waz;
    void entityState(const int tentity);
    void readConf();
    void slotImportTlf();
    void slotIOTAChanged();
    void setMyQrz(const QString &tqrz);
    QString getMyQrz() const;
    void setMyLocator(const QString &tlocator);
    QString getMyLocator() const;
    void showWhere(const int enti);

//    int band2Num(const QString &tband);
    
  //  Qso qso;
    QColor ledColor;
    Locator locator;
    QString myQrz;
    QString myLocator;
    QString klogDir;
    QString logFileName;
    QString aux;
    QString KLogVersion;


    int number;
    int rstrx;
    int rsttx;
    int band;
    int imode;
    int power;
    int i, j;
    int itemPos; // for modifying
    int enti; //Just for entity name show
    int entiBak;
    int callLen;
    int callLenPrev;
    int callLenFound;
    int beam; // the beam in degrees DELETE
    int distance;
    bool lastDelete;
    bool callFound;
    bool modify;
    bool prefixFound;
    bool dirExist;
    bool needToSave;
    bool actionSent;
    bool actionRec;
    QString mode;
    QString qrz;
    QString iota;
    QDateTime dateTime;
    QDate qslSen;
    QDate qslRec;
    QDate date;
    QTime time;
    QString comment;
    QString dateTimeString;
//    Preferences setupDialog;

    QPixmap *editdeletePixMap;
    QPixmap *editdeleteOffPixMap;
    QPixmap *qslRecPixMap;
    QPixmap *qslRecOffPixMap;
    QPixmap *qslSenPixMap;
    QPixmap *qslSenOffPixMap;


};

#endif
